src/main/java/model/Empresa.java
package model;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;

@Entity
@Inheritance(strategy=InheritanceType.SINGLE_TABLE)
public abstract class Empresa {

	@Id
	private String cnpj;
	private String razaoSocial;
	private String endereco;
	
	public String getCnpj() {
		return cnpj;
	}
	
	public void setCnpj(String cnpj) {
		this.cnpj = cnpj;
	}
	public String getRazaoSocial() {
		return razaoSocial;
	}
	public void setRazaoSocial(String razaoSocial) {
		this.razaoSocial = razaoSocial;
	}
	public String getEndereco() {
		return endereco;
	}
	public void setEndereco(String endereco) {
		this.endereco = endereco;
	}

}

src/main/java/model/Organizadora.java
package model;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;

@Entity
public class Organizadora extends Empresa implements IOrganizador {

	@OneToMany
	private List<Organizador> organizadores = new ArrayList<Organizador>();

	private double horasDedicadasDostrabalhadores = 0;

	public String getTipo() {
		return getClass().getSimpleName();
	}

	public double getHorasDedicadas() {
		return horasDedicadasDostrabalhadores;
	}

	public void setHorasDedicadasDostrabalhadores() {
		if (organizadores.isEmpty())
			horasDedicadasDostrabalhadores = 0;
		else{
			for(Organizador o : organizadores){
				horasDedicadasDostrabalhadores += o.getHorasDedicadas();
			}
		}
	}

	public List<Organizador> getOrganizadores() {
		return organizadores;
	}

	public void setOrganizadores(List<Organizador> organizadores) {
		this.organizadores = organizadores;
	}

	public double getHorasDedicadasDostrabalhadores() {
		return horasDedicadasDostrabalhadores;
	}

	public void setHorasDedicadasDostrabalhadores(double horasDedicadasDostrabalhadores) {
		this.horasDedicadasDostrabalhadores = horasDedicadasDostrabalhadores;
	}
	
	

}

src/main/java/controller/EmpresaBean.java
package controller;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.faces.bean.ApplicationScoped;
import javax.faces.bean.ManagedBean;

import dao.EmpresaDao;
import model.Empresa;
import model.Organizadora;
import model.Patrocinadora;

@ManagedBean
@ApplicationScoped
public class EmpresaBean implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private Patrocinadora patrocinadora = new Patrocinadora();
	private Organizadora organizadora = new Organizadora();

	private List<Empresa> empresasOrganizadoras = new ArrayList<Empresa>();
	private List<Empresa> empresasOrganizadorasEncontrados = new ArrayList<Empresa>();

	private List<Empresa> empresasPatrocinadoras = new ArrayList<Empresa>();
	private List<Empresa> empresasPatrocinadorasEncontrados = new ArrayList<Empresa>();

	private List<Empresa> todasAsEmpresas = new ArrayList<Empresa>();

	public EmpresaBean() {
		this.findAll();
	}

	public void findAll() {
		EmpresaDao daoEmpresa = new EmpresaDao();
		todasAsEmpresas = daoEmpresa.listaTodos(""); 
	}

	public List<Empresa> getListaDeEmpresas() {
		return todasAsEmpresas;
	}

	public void gravarPatrocinadora() {
		EmpresaDao daoEmpresa = new EmpresaDao();
		daoEmpresa.adiciona(patrocinadora);
		empresasPatrocinadoras.add(patrocinadora);
		findAll();
		patrocinadora = new Patrocinadora();
	}

	public void gravarOrganizadora() {
		EmpresaDao daoEmpresa = new EmpresaDao();
		daoEmpresa.adiciona(organizadora);
		empresasOrganizadoras.add(organizadora);
		findAll();
		organizadora = new Organizadora();
	}

	public void removerPatrocinadora() {
		EmpresaDao daoEmpresa = new EmpresaDao();
		daoEmpresa.remove(patrocinadora.getCnpj());
		empresasPatrocinadoras = daoEmpresa.listaTodos(patrocinadora.getClass().toString());
		findAll();
		patrocinadora = new Patrocinadora();
	}

	public void removerOrganizadora() {
		EmpresaDao daoEmpresa = new EmpresaDao();
		daoEmpresa.remove(organizadora.getCnpj());
		empresasOrganizadoras = daoEmpresa.listaTodos(organizadora.getClass().toString());
		findAll();
		organizadora = new Organizadora();
	}

	public Empresa recuperaPatrocinadora() {
		EmpresaDao daoEmpresa = new EmpresaDao();
		Empresa pessoaEncontrada = daoEmpresa.buscaPorCNPJ(patrocinadora.getCnpj(),
				patrocinadora.getClass().toString());
		return pessoaEncontrada;
	}

	public Empresa recuperaOrganizadora() {
		EmpresaDao daoEmpresa = new EmpresaDao();
		Empresa pessoaEncontrada = daoEmpresa.buscaPorCNPJ(organizadora.getCnpj(), organizadora.getClass().toString());
		return pessoaEncontrada;
	}

	public void findAllOrganizadoras() {
		EmpresaDao daoEmpresa = new EmpresaDao();
		empresasOrganizadoras = daoEmpresa.listaTodos(organizadora.getClass().toString());
	}

	public void findAllPatrocinadoras() {
		EmpresaDao daoEmpresa = new EmpresaDao();
		empresasPatrocinadoras = daoEmpresa.listaTodos(patrocinadora.getClass().toString());
	}

	public void atualizarPatrocinadora() {
		EmpresaDao daoPeessoa = new EmpresaDao();
		daoPeessoa.atualiza(patrocinadora);
		patrocinadora = new Patrocinadora();
		empresasPatrocinadoras = daoPeessoa.listaTodos(patrocinadora.getClass().toString());
	}

	public void atualizarOrganizadora() {
		EmpresaDao daoPeessoa = new EmpresaDao();
		daoPeessoa.atualiza(organizadora);
		organizadora = new Organizadora();
		empresasOrganizadoras = daoPeessoa.listaTodos(organizadora.getClass().toString());
	}

	public static long getSerialversionuid() {
		return serialVersionUID;
	}

	public Patrocinadora getPatrocinadora() {
		return patrocinadora;
	}

	public Organizadora getOrganizadora() {
		return organizadora;
	}

	public List<Empresa> getEmpresasOrganizadoras() {
		return empresasOrganizadoras;
	}

	public void setEmpresasOrganizadoras(List<Empresa> empresasOrganizadoras) {
		this.empresasOrganizadoras = empresasOrganizadoras;
	}

	public List<Empresa> getEmpresasOrganizadorasEncontrados() {
		return empresasOrganizadorasEncontrados;
	}

	public void setEmpresasOrganizadorasEncontrados(List<Empresa> empresasOrganizadorasEncontrados) {
		this.empresasOrganizadorasEncontrados = empresasOrganizadorasEncontrados;
	}

	public List<Empresa> getEmpresasPatrocinadoras() {
		return empresasPatrocinadoras;
	}

	public void setEmpresasPatrocinadoras(List<Empresa> empresasPatrocinadoras) {
		this.empresasPatrocinadoras = empresasPatrocinadoras;
	}

	public List<Empresa> getEmpresasPatrocinadorasEncontrados() {
		return empresasPatrocinadorasEncontrados;
	}

}

src/main/webapp/empresa/changeOrDeleteEmpresaPatrocinadora.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html">
<head>
<title>Empresa Patrocinadora</title>
</head>
<body>
	<h:form>
		<fieldset>
			<legend>Alterar ou Excluir empresa Patrocinadora</legend>
			<h:outputText value="CPF:" for="cpf"/>
			<h:inputText id="cpf" value="#{empresaBean.patrocinadora.cnpj}"/>
			<h:commandButton action="#{empresaBean.removerPatrocinadora}" value="Excluir" />
			<h:commandButton action="updateEmpresaPatrocinadora" value="Alterar" />
			<h:commandButton action="empresa" value="Voltar"/>
		</fieldset>
	</h:form>
</body>
</html>

src/main/webapp/empresa/createEmpresaPatrocinadora.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:p="http://primefaces.org/ui">
<head>
<title>Empresa Patrocinadora</title>
</head>
<body>
	<f:view>
		<h:form>
			<fieldset>
				<legend>Cadastro da Empresa Patrocinadora</legend>
				<h:panelGrid columns="2">
					<h:outputText value="CNPJ: " for="cnpj" />
					<h:inputText id="cnpj" value="#{empresaBean.patrocinadora.cnpj}" />
					<h:outputText value="Razão Social: " for="rsorg" />
					<h:inputText id="rsorg"
						value="#{empresaBean.patrocinadora.razaoSocial}" />
					<h:outputText value="Endereco: " for="endorg" />
					<h:inputText id="endorg"
						value="#{empresaBean.patrocinadora.endereco}" />
					<h:outputText value="Valor para patrocínio: " for="valor" />
					<h:inputText id="valor"
						value="#{empresaBean.patrocinadora.verbaAInvestir}" />

					<h:commandButton action="#{empresaBean.gravarPatrocinadora}"
						value="Criar" />
					<h:commandButton action="empresa" value="Voltar" />

				</h:panelGrid>
			</fieldset>
		</h:form>
	</f:view>
</body>
</html>

src/main/webapp/empresa/empresa.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:p="http://primefaces.org/ui">
<h:head>
	<title>Empresa</title>
</h:head>
<body>
	<f:view>
		<!-- Criando botões de comando e navegação -->
		<h:panelGrid title="Empresa Organizadora"> Empresa Organizadora
			<h:form>
				<h:commandButton action="createEmpresaOrganizadora"
					value="Cadastrar " />
				<h:commandButton action="changeOrDeleteEmpresaOrganizadora"
					value="Atualizar ou Remover" />
				<h:commandButton action="/index" value="voltar" />
			</h:form>
		</h:panelGrid>

		<h:panelGrid title="Empresa Patrocinadora"> Empresa Patrocinadora
			<h:form>
				<h:commandButton action="createEmpresaPatrocinadora"
					value="Cadastrar " />
				<h:commandButton action="changeOrDeleteEmpresaPatrocinadora"
					value="Atualizar ou Remover" />
				<h:commandButton action="/index" value="voltar" />
			</h:form>
		</h:panelGrid>


		<!-- Fazendo aparecer todas as pessoas -->
		<p:dataTable var="empresa" value="#{empresaBean.listaDeEmpresas}">
			<p:column headerText="CNPJ">
				<h:outputText value="#{empresa.cnpj}" />
			</p:column>

			<p:column headerText="Razão Social">
				<h:outputText value="#{empresa.razaoSocial}" />
			</p:column>

			<p:column headerText="Endereco">
				<h:outputText value="#{empresa.endereco}" />
			</p:column>
			
			<p:column headerText="Tipo">
				<h:outputText value="#{empresa.tipo}" />
			</p:column>

		</p:dataTable>


	</f:view>
</body>
</html>

src/main/webapp/empresa/updateEmpresaPatrocinadora.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html">
<head>
<title>Empresa Patrocinadora</title>
</head>
<body>
	<h:form>
		<fieldset>
			<legend>Atualizar Empresa Patrocinadora</legend>
			<h:panelGrid columns="2">
				<h:outputText value="CNPJ: " for="cnpj" />
					<h:inputText id="cnpj" value="#{empresaBean.patrocinadora.cnpj}" />
					<h:outputText value="Razão Social: " for="rsorg" />
					<h:inputText id="rsorg"
						value="#{empresaBean.patrocinadora.razaoSocial}" />
					<h:outputText value="Endereco: " for="endorg" />
					<h:inputText id="endorg"
						value="#{empresaBean.patrocinadora.endereco}" />
					<h:outputText value="Valor para patrocínio: " for="valor" />
					<h:inputText id="valor"
						value="#{empresaBean.patrocinadora.verbaAInvestir}" />

					
				<h:commandButton action="#{empresaBean.atualizarPatrocinadora}"
					value="Atualizar" />
				<h:commandButton action="empresa" value="Voltar" />
			</h:panelGrid>
		</fieldset>
	</h:form>
</body>
</html>